//Example program demonstrating the RowConverter
#include "ffdb.h"
#include "ffdb_io.h"
#include "ffdb_convert.h"
#include <stdio.h>

int main(void) {
	RowSet rowset_user;
	if(!ReadFromFile("example_db_user.ffdb",&rowset_user)) {
		fprintf(stderr,"Could not read from user database\n");
		return -1;
	}
	
	printf("There are %ld users in the database\n", (long)rowset_user.size());
	
	const RowSetDescriptor &desc = rowset_user.descriptor();
	
	//native variables
	int id;
	char username[128];
	//Set up the converter
	LockedRowConverter converter;
	converter.lock(desc);
	converter.describe("id",&id);
	converter.describe("username",username,sizeof(username));
	
	for(RowSet::const_iterator iter=rowset_user.begin();
	    iter!=rowset_user.end();
	    iter++)
	{
		converter.toNative(*iter);
		printf("record %u: id=%d username=%s\n",
		       (unsigned)(iter-rowset_user.begin()),
		       id,
		       username
		      );
	}
	return 0;
}
