//Example program demonstrating the Unique operation
#include "ffdb.h"
#include "ffdb_io.h"
#include "ffdb_op.h"
#include "ffdb_util.h"
#include <stdio.h>

int main(void) {
	RowSet rowset_quota;
	if(!ReadFromFile("example_db_quota.ffdb",&rowset_quota)) {
		fprintf(stderr,"Could not read from quota database\n");
		return -1;
	}
	
	//project first on disk to make the unique operation interesting
	RowSet rowset_tmp;
	Projection(rowset_quota,&rowset_tmp,"disk",(char*)0);
	
	//Now make the result set unique
	RowSet result;
	Unique(rowset_tmp,&result,"disk",(char*)0);
	
	printf("Unique disks mentioned in quota:\n");
	dump(result,stdout);
	
	return 0;
}
