#include <string.h>

class Compare_RowDigest {
public:
	bool eq(const RowSetDigest::RowDigest &rd1, const RowSetDigest::RowDigest &rd2) const {
		if(rd1.size!=rd2.size) return false;
		return memcmp(rd1.ptr,rd2.ptr,rd1.size)==0;
	}
	bool ne(const RowSetDigest::RowDigest &rd1, const RowSetDigest::RowDigest &rd2) const {
		if(rd1.size!=rd2.size) return true;
		return memcmp(rd1.ptr,rd2.ptr,rd1.size)!=0;
	}
	bool lt(const RowSetDigest::RowDigest &rd1, const RowSetDigest::RowDigest &rd2) const {
		size_t ms=rd1.size;
		if(rd2.size<ms) ms=rd2.size;
		int rc = memcmp(rd1.ptr,rd2.ptr,ms);
		if(rc<0) return true;
		if(rc>0) return false;
		return rd1.size<rd2.size;
	}
	bool gt(const RowSetDigest::RowDigest &rd1, const RowSetDigest::RowDigest &rd2) const {
		return lt(rd2,rd1);
	}
	//used by sort
	int operator()(const RowSetDigest::RowDigest &rd1, const RowSetDigest::RowDigest &rd2) {
		return lt(rd1,rd2);
	}
};
