#ifndef _FFDB_ROWSETDIGEST_H_
#define _FFDB_ROWSETDIGEST_H_

#include "ffdb.h"
#include <vector>

class RowSetDigest {
public:
	struct RowDigest {
		char *ptr;
		size_t size;
		RowSet::const_pointer row_ptr;
	};
private:
	char *buffer;
	size_t buffer_size;
	size_t buffer_bytes;
	std::vector<RowDigest> digest;
	RowSetDigest(const RowSetDigest&);
	RowSetDigest& operator=(const RowSetDigest&);
public:
	RowSetDigest();
	~RowSetDigest();
	
	void reserve(size_t rows) { digest.reserve(rows); }
	void reserve_raw(size_t rawsize);
	
	void digest_alloc(RowSet::const_pointer row_ptr);
	void digest_append_last(const void *p, size_t bytes);
	void pop_back() { digest.pop_back(); }
	
	typedef std::vector<RowDigest>::const_iterator const_iterator;
	typedef std::vector<RowDigest>::iterator iterator;
	iterator       begin()       { return digest.begin(); }
	const_iterator begin() const { return digest.begin(); }
	iterator       end()         { return digest.end(); }
	const_iterator end()   const { return digest.end(); }
	size_t size() const { return digest.size(); }
	size_t raw_size() const { return buffer_bytes; }
	void clear();
};

#endif
