#include "ffdb_op.h"
#include "ffdb.h"


bool PreparedUnion::execute(const RowSet &row_set_1, const RowSet &row_set_2, RowSet *result) {
	if(!is_type_compatible(row_set_1.descriptor(),row_set_2.descriptor()))
		return false;
	if(row_set_1.size()>row_set_2.size()) {
		*result = row_set_1;
		result->reserve(result->size() + row_set_2.size());
		for(RowSet::const_iterator iter=row_set_2.begin();
		    iter!=row_set_2.end();
		    iter++)
		{
			result->push_back(*iter);
		}
	} else {
		*result = row_set_2;
		result->reserve(result->size() + row_set_1.size());
		for(RowSet::const_iterator iter=row_set_1.begin();
		    iter!=row_set_1.end();
		    iter++)
		{
			result->push_back(*iter);
		}
	}
	return true;
}


bool Union(const RowSet &row_set_1, const RowSet &row_set_2, RowSet *result) {
	PreparedUnion prep_union;
	return prep_union.execute(row_set_1,row_set_2,result);
}
