#include "ffdb.h"
#include "ffdb_io.h"
#include "ffdb_op.h"
#include <stdio.h>
#include <string.h>


int main(int argc, char **argv) {
	if(argc<4) {
		fprintf(stderr,"usage error\n");
		return -1;
	}
	RowSet rowset1;
	if(!ReadFromFile(argv[1],&rowset1)) {
		printf("Could not load DB\n");
		return -1;
	}
	RowSet rowset2;
	if(!ReadFromFile(argv[2],&rowset2)) {
		printf("Could not load DB\n");
		return -1;
	}
	
	PreparedJoin prep_join;
	for(int i=4; i<argc; i+=2) {
		prep_join.add_relation(argv[i],argv[i+1]);
	}
	for(int i=0; i<10; i++) {
		RowSet result_rowset;
		if(!prep_join.execute(rowset1,rowset2,&result_rowset)) {
			fprintf(stderr,"Join error\n");
			return -1;
		}
	}
	return 0;
}
