#include "ffdb.h"
#include "ffdb_io.h"
#include "ffdb_op.h"
#include <stdio.h>

int main(int argc, char **argv) {
	if(argc!=2) {
		fprintf(stderr,"usage error\n");
		return -1;
	}
	RowSet rowset;
	if(!ReadFromFile(argv[1],&rowset)) {
		fprintf(stderr,"Could not read from test file\n");
		return -1;
	}

	LockedSelection locked_sel;
	locked_sel.add_condition("ispvn_id",cond_eq);
	locked_sel.add_condition("username",cond_eq);
	
	locked_sel.lock(rowset);
	
	for(int i=0; i<100; i++) {
		RowSet result;
		locked_sel.set_value(0,(int64_t)1);
		locked_sel.set_value(1,"username50088");
		if(!locked_sel.execute(&result) || result.size()!=1) {
			fprintf(stderr,"execute error\n");
			return -1;
		}
	}
	return 0;
}
