#include "ffdb.h"
#include "ffdb_io.h"
#include "ffdb_op.h"
#include <stdio.h>
#include <string.h>


int main(int argc, char **argv) {
	if(argc<5) {
		fprintf(stderr,"usage error\n");
		return -1;
	}
	RowSet rowset1;
	if(!ReadFromFile(argv[1],&rowset1)) {
		printf("Could not load DB\n");
		return -1;
	}
	RowSet rowset2;
	if(!ReadFromFile(argv[2],&rowset2)) {
		printf("Could not load DB\n");
		return -1;
	}
	
	
	PreparedDifference prep_difference;
	for(int i=4; i<argc; i+=2) {
		prep_difference.add_relation(argv[i],argv[i+1]);
	}
	
	RowSet result_rowset;
	if(!prep_difference.execute(rowset1,rowset2,&result_rowset)) {
		fprintf(stderr,"Intersection error\n");
		return -1;
	}
	if(!WriteToFile(argv[3],result_rowset)) {
		fprintf(stderr,"Could not write to result file\n");
		return -1;
	}
	return 0;
}
